//*****************************************************************************
//*
//*
//*		VirtualIoctl.h
//*
//*
//*****************************************************************************
#ifndef 	__VIRTUALIOCTL_H__
#define 	__VIRTUALIOCTL_H__


#define		IOCTL_VNET_INIT_PORT		CTL_CODE(FILE_DEVICE_UNKNOWN, 0x60, METHOD_BUFFERED,  FILE_ANY_ACCESS)
#define		IOCTL_VNET_CONNECT			CTL_CODE(FILE_DEVICE_UNKNOWN, 0x61, METHOD_BUFFERED,  FILE_ANY_ACCESS)
#define		IOCTL_VNET_INFO				CTL_CODE(FILE_DEVICE_UNKNOWN, 0x62, METHOD_BUFFERED,  FILE_ANY_ACCESS)
#define		IOCTL_VNET_VERSION			CTL_CODE(FILE_DEVICE_UNKNOWN, 0x63, METHOD_BUFFERED,  FILE_ANY_ACCESS)
#define		IOCTL_VNET_SETEVENT			CTL_CODE(FILE_DEVICE_UNKNOWN, 0x64, METHOD_BUFFERED,  FILE_ANY_ACCESS)
#define		IOCTL_VNET_RESET			CTL_CODE(FILE_DEVICE_UNKNOWN, 0x65, METHOD_BUFFERED,  FILE_ANY_ACCESS)
#define		IOCTL_VNET_READ_PACKET		CTL_CODE(FILE_DEVICE_UNKNOWN, 0x66, METHOD_OUT_DIRECT,FILE_ANY_ACCESS)
#define		IOCTL_VNET_WRITE_PACKET		CTL_CODE(FILE_DEVICE_UNKNOWN, 0x67, METHOD_IN_DIRECT, FILE_ANY_ACCESS)
#define		IOCTL_VNET_GET_INTERNAL		CTL_CODE(FILE_DEVICE_UNKNOWN, 0x68, METHOD_BUFFERED,  FILE_ANY_ACCESS)
#define		IOCTL_VNET_PACKET_SIZE		CTL_CODE(FILE_DEVICE_UNKNOWN, 0x69, METHOD_BUFFERED,  FILE_ANY_ACCESS)

#define		VNET_READ_EVENT				0
#define		VNET_WRITE_EVENT			1

#ifndef		NIC_MAX_CONNECTIONS
#define 	NIC_MAX_CONNECTIONS			1
#endif 	

typedef struct
	{
	UINT	uPort;							// is the port number (0...NIC_MAX_CONNECTIONS-1, 0xFFFFFFFF=dynamic 0x80000000+N=deinitalize)									
	UCHAR	aMacAddr[6];					// is the mac address for the port (00:00:00:00:00:00 for dynamic)
	UCHAR	ucConnected;					// set the connect flag
	UCHAR	ucPromiscuous;					// receive all mac adresses
	}VnetInitData;

typedef struct
	{
	UINT	uPort;							// is the port number (0...NIC_MAX_CONNECTIONS-1)									
	UCHAR	ucConnected;					// set the connect flag
	UCHAR	ucUnused[3];					// unused
	}VnetConnectData;

typedef struct
	{
	UINT	uAdapterNumber;					// is the number of the adapter
	UINT	uPortsCount;					// is the port number (0...NIC_MAX_CONNECTIONS-1, 0xFFFFFFFF=dynamic)										
	UINT	uPortsUsed;						// is the count of used ports
	UINT	uPortsConnected;				// is the count of connected
	}VnetInfoData;

typedef struct
	{
	UINT	uVersion;						// is the version number of the driver (NIC_VENDOR_DRIVER_VERSION)
	}VnetVersionData;

typedef struct
	{
	UINT	uPort;							// is the port number for sending and receiving									
	UINT	uUnused;						// fill to 64 bit
	union	{
	HANDLE	hEvent;							// is the receive event for incomming packets
	UINT	aDummy[2];						// be sure tha it hase a size of 64 bit
			};
	}VnetSetEventData;

typedef struct
	{
	UINT	uPort;							// is the port number which should be reseted
	}VnetResetData;

typedef struct
	{
	LONG	lSendDriver;					// count of sended packets from driver
	LONG	lSendPort;						// count of sended packets from other port
	LONG	lWaitDone;						// count of packets which are puted into the wait list
	LONG	lWaitError;						// count of packets which are puted into the wait list
	LONG	lRecvDriver;					// count of received packets from driver
	LONG	lRecvPort;						// count of received packets from other port
	LONG	lRecvWait;						// count of received packets from other port
	LONG	lRecvAll;						// count of all received packets from wait list
	LONG	lCopyError;						// count of copy errors (no receive buffer)
	LONG	lQueryError;					// count of query errors (at NdisQueryBufferSafe)
	LONG	lLoopCount;						// count of loops in the packet buffer
	LONG	lResetCount;					// count of resets of the packet buffer
	}VnetDbg;

typedef struct
	{
	UINT	uPortCount;						// is the the count of simulated ports
	UINT	uRecvSize;						// is the size of the port receive buffer	
	LONG	lRecvPortNotTarget;				// count of received packets from a port with not target
	LONG	lRecvAllocErrorM;				// count of allocation errors at dreiver receive (memories)
	LONG	lRecvAllocErrorP;				// count of allocation errors at dreiver receive (packets)
	LONG	lRecvAllocErrorB;				// count of allocation errors at dreiver receive (buffers)
	LONG	lRecvFromPort;					// count of received packets form a port
	LONG	lSendByDriverAll;				// count of all received packets from wait list
	LONG	lSendNotConnected;				// count of sendet packets when no port is connected
	LONG	lSendBufferError;				// count of sendet packets with buffer errors (at NdisGetFirstBufferFromPacketSafe)
	LONG	lSendDriverNoTarget;			// count of sendet packets from driver with target
	LONG	lCompleteCount;					// count of completed packets
	LONG	lCancelCount;					// count of cancelded packets
	LONG	lReturnCount;					// count of returned packets
	LONG	lProcReset;						// count of active reset calls
	LONG	lProcSendPackets;				// count of active send packets calls
	LONG	lProcCancelPackets;				// count of active cancel packets calls
	LONG	lProcReturnPackets;				// count of active return packets calls
	VnetDbg	aPortInfo[NIC_MAX_CONNECTIONS];
	}VnetInternalData;




#endif 	